<?php

namespace Notes\Route\Annotation\Method;

class Route implements \Notes\Annotation {

    /**
     * @required
     */
    public string $name;

    /**
     * @required
     */
    public string $route;

    public string $method;

    public string $base;

    public array $methods;

    public string $class;

    public string $classMethod;

    public bool $currentRoute = false;

    public function __construct($route = null, $name = null, $method = null)
    {
        if ( $route !== null ) {
            $this->route = $route;
        }

        if ( $name !== null ) {
            $this->name = $name;
        }

        if ( $method !== null ) {
            $this->method = $method;
        }
    }

    public function getRoute() : string
    {
        return rtrim("/" . trim(isset($this->base) ?
                "/" . trim($this->base, "/") . "/" . ltrim($this->route, "/")
                :
                "/" . ltrim($this->route, "/"), "/"), '/');
    }

    public function matchRouteName(string $name) : bool
    {
        return strtolower($this->name) === strtolower($name);
    }

    public function isRoute(string $name) {
        return $this->name === $name;
    }

    public function currentRoute(bool|null $value = null ) {
        return is_null($value) ? $value : $this->currentRoute = $value;
    }
}
